//+------------------------------------------------------------------+
//|                                            Simple average EA.mq4 |
//|                                                     Teja Siddani |
//|                                         https://www.tradefxp.com |
//+------------------------------------------------------------------+
#property copyright "Teja Siddani"
#property link      "https://www.tradefxp.com"
#property version   "1.04"
#property strict


// +-------------- iNPUTS -------+

enum Trade { Buy_Only, Sell_Only };

extern string           oooooooo            = " ---  Main Indicator Settings --- "; // --------------------------------------------


extern bool     EAactive                    = false; // Indicator Active 
extern string  text                         = "-- If Indicator False sellect Trade Type  ";
extern Trade  signal                        =  Buy_Only; // Trade type 
extern string   Indiactor_file              = "pricechannel_stop_v1.3"; // Indicator FIle Name 
extern ENUM_TIMEFRAMES Indicator_Period     = 0;  // Indicator Period 
extern double   ChannelPeriod               = 21;   // Chaneel Period
extern double   Risk                        = 0.3;  // Risk Value



extern string          ooooooooo            = " ---  Magic Number  --- ";  // ------------------------------------------------------
extern int     Magic                        = 1325; // Order Magic Number
extern int      Slippage                    = 3;    // Max Slippage
extern string          qooooooooo            = " ---  Martingale Settings --- ";  // ------------------------------------------------------ 
extern double FixLot            = 0.01; // Lot Size in Starting 
extern double LotSizeincrese    = 0.01; //  Adding lot size ( 0 = not used )
extern double LotSizeMultiplay  = 0; // Multiplied lot size ( 0 = not used )
extern string          aaaooooooooo            = " ---  Orders Entry Settings --- ";  // ------------------------------------------------------
extern int    maxtrade          = 11; // Max Trades open
extern double Grid              = 10; // Grid Gap
extern double Stoploss          = 0;  // Stoploss
extern double StoplossAv        = 20;  // Average + Points
extern double TakeProfit        = 500; // Take Profit

double UpTrendSignal_line   = EMPTY_VALUE;
double DownTrendSignal_line = EMPTY_VALUE;

string signaltype;
double lastlotsize;



 // ----------------- Buttons  -------------------------------------
 bool  buttonstate                  = true; // Button state, trading on/off, true == trade
 bool  buttonstatecloseall          = false;
 bool  buttonstateclosebuy          = false;
 bool  buttonstateclosesell         = false;
 
  const int      buttonlocation      = CORNER_LEFT_LOWER; // Buttons Location 
 const string   buttonName          = "Pause ";
 const int      buttonXposition     = 20;
 const int      buttonYposition     = 55;
 const int      buttonWidth         = 70;
 const int      buttonHeight        = 21;
 extern string tab                  = "------------------"; // ----------------------------------------------
 
 const string   buttonFont          = "Arial Bold";
 const int      buttonFontSize      = 8;
 const int      buttonColor         = clrBlack;
 
 // When Running 
 const string   buttonTextRun       = " Running";
 const int      buttonColorRun      = clrLightGreen;
 
 // when paused
 const string   buttonPaused        = " Paused";
 const int      buttonColorPasuse   = clrOrange; 
 
// 
const string    buttonworks         = "In Proccess";

//+--------------------------
int OnInit(){
    
    
    createButton("Close", buttonXposition , buttonYposition , buttonWidth, buttonHeight, buttonlocation,  buttonFont, buttonFontSize, buttonColor ); // Close button 
    createButton(buttonName, ( buttonXposition + buttonWidth + 5 ), buttonYposition, buttonWidth, buttonHeight, buttonlocation, buttonFont, buttonFontSize, buttonColor ); // Pause button
    createButton("Close Buy", buttonXposition , ( buttonYposition -buttonHeight -5 ) , buttonWidth, buttonHeight, buttonlocation,  buttonFont, buttonFontSize, buttonColor ); // Close Buy button 
    createButton("Close Sell", ( buttonXposition + buttonWidth + 5 ) , ( buttonYposition -buttonHeight -5 ) , buttonWidth, buttonHeight, buttonlocation,  buttonFont, buttonFontSize, buttonColor ); // Close Sell button 
    return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason){

    ObjectDelete(0, buttonName);
    ObjectDelete(0, "Close");
    ObjectDelete(0, "Close Buy");
    ObjectDelete(0, "Close Sell");
    
}

void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam ) {
    
    if ( sparam == "Close" &&  id == CHARTEVENT_OBJECT_CLICK ) {
        buttonstatecloseall = ObjectGetInteger(0,  "Close", OBJPROP_STATE, 0);
        
              
    }
    
    if ( sparam == "Close Buy" &&  id == CHARTEVENT_OBJECT_CLICK ) {
        buttonstateclosebuy = ObjectGetInteger(0,  "Close Buy", OBJPROP_STATE, 0);
              
    }
    
    if ( sparam == "Close Sell" &&  id == CHARTEVENT_OBJECT_CLICK ) {
        buttonstateclosesell = ObjectGetInteger(0,  "Close Sell", OBJPROP_STATE, 0);
              
    }
    
    if (sparam != buttonName) return;
    if ( id != CHARTEVENT_OBJECT_CLICK) return;
    
    SetButtonSate(ObjectGetInteger(0, buttonName, OBJPROP_STATE, 0));
    //Alert(buttonName);

}

//+--------------------------
void OnTick()
  {
//---
       
       
       //int totalorders = OrdersTotal();
       // Checking orders by symbol
       int      SymbOrdTot  =  0;
       double   TPAverage = 0;
       double   TPAveragePrice = 0;
       double   totallots   =0;
        //  if ( SymbOrdTot < OrdersTotal() )  
        for (int OrdersCount = 0; OrdersCount < OrdersTotal(); OrdersCount ++) 
             {  
                  if( OrderSelect(OrdersCount, SELECT_BY_POS, MODE_TRADES ) )
                  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic  ) 
                  {
                     SymbOrdTot = SymbOrdTot + 1;  
                     
                    TPAverage  += OrderOpenPrice()*OrderLots(); // StoplossAverage +
                    totallots += OrderLots();
                     //SymbOrdTicket = OrderTicket();  
                         
                  }
             }
         // Moving Stoploss to avarage   
         for (int OrdersCount = OrdersTotal(); OrdersCount >= 0 ; OrdersCount --) {
          Comment("Live  ", SymbOrdTot, "\n" );
          if( OrderSelect(OrdersCount, SELECT_BY_POS) ) { 
          if (  OrderSymbol() == Symbol() && OrderType() == OP_BUY && SymbOrdTot >= 2 ) {
               
               TPAveragePrice = NormalizeDouble( ( TPAverage / totallots ) + (StoplossAv *_Point) , Digits );
                 if ( TPAveragePrice > Close[0] && OrderTakeProfit() != TPAveragePrice ) {
                   double check = OrderModify( OrderTicket(), OrderOpenPrice(), OrderStopLoss() , TPAveragePrice, 0 , clrNONE ); // StoplossAveragePrice > OrderOpenPrice()?( StoplossAverage / SymbOrdTot ):StoplossAveragePrice 
                   if ( check > 0) { Print( "Order Modified"); }  else { Print( " Order Modify Error: ",GetLastError() );}
                   Comment("B - Live  ", SymbOrdTot, "\n","Average price: ",  TPAveragePrice, "\n");  
                 }
            }
            
          if ( OrderType() == OP_SELL && OrderSymbol() == Symbol()  && SymbOrdTot >= 2 ) { // 
              
               TPAveragePrice = NormalizeDouble( ( TPAverage / totallots ) - (StoplossAv *_Point) , Digits );
               if ( TPAveragePrice < Close[0] && OrderTakeProfit() != TPAveragePrice ) {
                   double check = OrderModify( OrderTicket(), OrderOpenPrice(), OrderStopLoss() , TPAveragePrice, 0 , clrNONE ); // StoplossAveragePrice < OrderOpenPrice()?( StoplossAverage / SymbOrdTot ):StoplossAveragePrice
                   if ( check > 0) { Print( "Order Modified"); }  else { Print( " Order Modify Error: ",GetLastError() );}
                   Comment("S-Live  ", SymbOrdTot, "\n","Average price: ",  TPAveragePrice ); 
                  
                    }
                } 
          }
       }
      
      
      //Alert( signaltype);
      if ( signaltype == "Sell"  ) {
      
            static double Nextsellprice;
            
            // if we have no open positions
            if ( OrdersTotal() == 0 || SymbOrdTot == 0  ) { Nextsellprice = 0; }
            
      
           // if Bid price is <= next sell price 
           // or Nextsellprice == 0
           if ( ((Bid >= Nextsellprice ) || ( Nextsellprice == 0 ) ) && ( SymbOrdTot <= maxtrade ))
           
           // if we have sell signal
           if (signaltype == "Sell"  )
           {
              // sending Sell Order
              if ( SymbOrdTot == 0  && buttonstate == true) { OpenTrade (Symbol(),OP_SELL,FixLot,Bid, Slippage, Stoploss, TakeProfit, "Simple Grid", Magic, 0, clrNONE );  }
              if ( SymbOrdTot >= 1 ) {
                
                double nextlot = LotSizeMultiplay == 0? lastlotsize + LotSizeincrese : lastlotsize * LotSizeMultiplay;
                //Alert(nextlot);
                OpenTrade (Symbol(),OP_SELL,nextlot,Bid, Slippage, Stoploss, TakeProfit, "Simple Grid", Magic, 0, clrNONE );
              
              }
              
              
              // Seting Next Order price
              Nextsellprice = Bid + Grid * _Point;
              
           }
        }



      if ( signaltype == "Buy"  ) {
            
          static double NextBuyprice;
          
          if ( OrdersTotal() == 0 || SymbOrdTot == 0 ) { NextBuyprice = 0; }
          
          if (  ( ( Ask <= NextBuyprice ) || (  NextBuyprice == 0 ) )  && ( SymbOrdTot <= maxtrade ) ) {
          
            if ( signaltype == "Buy"  ) {
                       
                if ( SymbOrdTot == 0 && buttonstate == true ) { OpenTrade (Symbol(),OP_BUY,FixLot,Ask, Slippage, Stoploss, TakeProfit, "Simple Grid", Magic, 0, clrNONE );  }
                
                if ( SymbOrdTot >= 1 ) {
                
                double nextlot = LotSizeMultiplay == 0? lastlotsize + LotSizeincrese : lastlotsize * LotSizeMultiplay;
                OpenTrade (Symbol(),OP_BUY,nextlot,Ask, Slippage, Stoploss, TakeProfit, "Simple Grid", Magic, 0, clrNONE );
                
                }
                
                           
                NextBuyprice = Ask - Grid *_Point;
            }
          
          }
      
      }

       if (EAactive == true ) { Getsignal(); }
       if ( EAactive == false && signal == Sell_Only ) { signaltype = "Sell"; }
       if ( EAactive == false && signal == Buy_Only ) { signaltype = "Buy"; }
       
       
       // Close all Buttons
       if ( buttonstatecloseall == true ){
            
            ObjectSetInteger(0, "Close", OBJPROP_STATE, buttonstatecloseall);
            ObjectSetString(0, "Close", OBJPROP_TEXT,  buttonworks);
            Print("Close All Button: Closing Trades");
            CloseallTrades();
       
       } else {  ObjectSetString(0, "Close", OBJPROP_TEXT,  "Close All");
                 ObjectSetInteger(0, "Close", OBJPROP_STATE, buttonstatecloseall);}
                 
                 
       // Clsoe Buy Button
       if ( buttonstateclosebuy == true ){
            
            ObjectSetInteger(0, "Close Buy", OBJPROP_STATE, buttonstateclosebuy);
            ObjectSetString(0, "Close Buy", OBJPROP_TEXT,  buttonworks);
            Print("Close Buy Button: Closing Trades");
            
            CloseTradestype(OP_BUY);
       
       } else {  ObjectSetString(0, "Close Buy", OBJPROP_TEXT,  "Close Buy");
                 ObjectSetInteger(0, "Close Buy", OBJPROP_STATE, buttonstateclosebuy);
                 ChartRedraw(0);}
                 
       // Close Sell Button
       // Clsoe Buy Button
       if ( buttonstateclosesell == true ){
            
            ObjectSetInteger(0, "Close Sell", OBJPROP_STATE, buttonstateclosesell);
            ObjectSetString(0, "Close Sell", OBJPROP_TEXT,  buttonworks);
            Print("Close Sell Button: Closing Trades");
            
            CloseTradestype(OP_SELL);
       
       } else {  ObjectSetString(0, "Close Sell", OBJPROP_TEXT,  "Close Sell");
                 ObjectSetInteger(0, "Close Sell", OBJPROP_STATE, buttonstateclosesell);
                 ChartRedraw(0);}
       
        
//---
}


void Getsignal() {

        // indicator 
        UpTrendSignal_line      = iCustom(Symbol(),Indicator_Period,Indiactor_file,ChannelPeriod,Risk,0,1);
        DownTrendSignal_line    = iCustom(Symbol(),Indicator_Period,Indiactor_file,ChannelPeriod,Risk,1,1);
        
        if ( UpTrendSignal_line != 0 && UpTrendSignal_line < 5000 ) signaltype = "Buy";
        if ( DownTrendSignal_line != 0 && DownTrendSignal_line < 5000 ) signaltype = "Sell";

}

void OpenTrade (string symbol, int Ordertype, double lotsize, double price, int slippage, double SL, double TP, string comment, int magic, int experied, int Color ){
    
      //Alert("called");
      lastlotsize = 0;
      int open = OrderSend(symbol,  Ordertype, lotsize, price, slippage,0, 0, comment, magic, experied , Color);
      if ( open > 0 ) { 
                    
       if ( OrderSelect(open, SELECT_BY_TICKET)) {
                    
            double op  = OrderOpenPrice();
            int type   = OrderType();
            lastlotsize = OrderLots();
            if ( type == OP_BUY ) {
                double sl  = SL != 0? op - SL*Point:0;
                double tp  = TP !=0? op + TP * Point:0;
                            
                double modify = OrderModify(OrderTicket(), OrderOpenPrice(),sl,tp,0,clrNONE);
                if ( modify < 0 )  { Print(OrderTicket(), " Tp / SL   Not able to set Error: ", GetLastError()) ;}
               } 
            if ( type == OP_SELL ) {
                double sl  = SL != 0? op + SL*Point:0;
                double tp  = TP !=0? op - TP * Point:0;
                            
                double modify = OrderModify(OrderTicket(), OrderOpenPrice(),sl,tp,0,clrNONE);
                if ( modify < 0 )  { Print(OrderTicket(), " Tp / SL   Not able to set Error: ", GetLastError()) ;}
               } 
         }
                
       }

}

// Create Buttons 

void createButton(string ButtonName, int ButtonXpostion, int ButtonYpostion, int ButtonWidth, int ButtonHeight,int ButtonCorner, string ButtonFont,int ButtonFontSize, int ButtonColor) {
    
    ObjectDelete(0, ButtonName);
    ObjectCreate(0, ButtonName, OBJ_BUTTON,0,0,0);
    ObjectSetInteger(0, ButtonName, OBJPROP_XDISTANCE, ButtonXpostion);
    ObjectSetInteger(0, ButtonName, OBJPROP_YDISTANCE, ButtonYpostion);
    ObjectSetInteger(0, ButtonName, OBJPROP_XSIZE, ButtonWidth);
    ObjectSetInteger(0, ButtonName, OBJPROP_YSIZE, ButtonHeight);
    ObjectSetInteger(0, ButtonName, OBJPROP_CORNER, ButtonCorner);
    ObjectSetString(0, ButtonName, OBJPROP_FONT, ButtonFont);
    ObjectSetInteger(0, ButtonName, OBJPROP_FONTSIZE, ButtonFontSize);
    ObjectSetInteger(0, ButtonName, OBJPROP_COLOR, ButtonColor);
    
    
    SetButtonSate(buttonstate);


}

void SetButtonSate(bool state) {

        buttonstate = state;
        
        ObjectSetInteger(0, buttonName, OBJPROP_STATE, buttonstate);
        ObjectSetString(0, buttonName, OBJPROP_TEXT, ButtonText());
        ObjectSetInteger(0, buttonName, OBJPROP_BGCOLOR, ButtonColor());
        if ( buttonstate == false ) { Print("Pause Button Activated"); }
        ChartRedraw(0);
        
}

string ButtonText(){

    return(buttonstate? buttonTextRun: buttonPaused);
}

int ButtonColor(){

    return( buttonstate? buttonColorRun: buttonColorPasuse );
}

void CloseTradestype(int ordertype ){

     // Closing  Order   
        
           
           for ( int i = OrdersTotal() -1; i >= 0; i-- ) {
           
                if ( OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
                    if ( OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == ordertype ) { //&& OrderMagicNumber() == inpMagicNumber && OrderType() == OP_SELL
                         
                         int orderclose1 = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),0 );
                         if ( orderclose1 > 1) { Print( " Orders Not close", GetLastError()  );}
                         }
                    }
            }
            
          if ( ordertype == OP_BUY ) { buttonstateclosebuy = false;} 
          if ( ordertype == OP_SELL ) { buttonstateclosesell = false;} 
        // --- Closing Buy Order 


}

void CloseallTrades( ){

     // Closing  Order   
        
           
           for ( int i = OrdersTotal() -1; i >= 0; i-- ) {
           
                if ( OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
                    if ( OrderSymbol() == Symbol() && OrderMagicNumber() == Magic  ) { //&& OrderMagicNumber() == inpMagicNumber && OrderType() == OP_SELL
                         
                         int orderclose1 = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),0 );
                         if ( orderclose1 > 1) { Print( " Orders Not close", GetLastError()  );}
                         }
                    }
            }
            
          //Alert("closed");
          buttonstatecloseall = false;
         
        // --- Closing Buy Order 


}